# Real.h File Reference

## Defines
#define | mypi 3.1415926535
#define | my2pow14 16384.0
#define | my2pow15Minus1 32767.0
#define | dsOverflow 32000
#define | Mul(xx, yy) ((xx)*(yy))
#define | Div(xx, yy) ((xx)/(yy))
#define | DivClip(xx, yy) ((xx)/(yy))
## Functions
real | RealAtan2 (real sin, real cos)
real | RealAbs (real xx)
real | RealSin (real xx)
real | RealCos (real xx)
real | RealTan (real xx)
real | RealSqrt (real xx)
real | RealExp (real xx)
real | RealLog (real xx)
real | RealFloor (real xx)
real | RealCeil (real xx)
void | RealArcSinCos (real sin, real cos, real &angle)
void | RealSinCos (real angle, real &sin, real &cos)
real | FixedToReal (int32 xx)
real | Int16ToReal (int16 xx)
real | UInt16ToReal (uint16 xx)
int16 | RealToInt16 (real xx)
uint16 | RealToUInt16 (real xx)
real | Int32ToReal (int32 xx)
real | UInt32ToReal (uint32 xx)
int32 | RealToInt32 (real xx)
uint32 | RealToUInt32 (real xx)
int32 | RoundRealToInt32 (real xx)
int16 | RoundRealToInt16 (real xx)
int32 | TruncRealToInt32 (real xx)
uint32 | TruncRealToUInt32 (real xx)
int16 | TruncRealToInt16 (real xx)
uint16 | TruncRealToUInt16 (real xx)
int32 | RealToFixed (real xx)
void | RealToReal64 (real xx, real64 &value)
real64 | RealToReal64 (real xx)
real32 | RealToReal32 (real xx)
real | Real32ToReal (real32 xx)
real | Real64ToReal (real64 value)
real | Real64ToRealCheck (real64 value, int *overflow=0)
real | RadToDeg (real xx)
real | DegToRad (real xx)
real | RealMul2 (real xx)
real | RealMul4 (real xx)
real | RealMul8 (real xx)
real | RealMul16 (real xx)
int | MultiplyClip (real &xx, const real yy)
real | RealMul2Power (real xx, int16 yy)
real | RealDiv2 (real xx)
real | RealDiv4 (real xx)
real | RealDiv8 (real xx)
real | RealDiv16 (real xx)
real | RealPow (real xx, real yy)
real32 | Spline (real32 x, const int32 knotsCount, real32 *knots)
real32 | Spline4 (real32 x, real32 *knots)
## Variables
const real | kRealMinusOne = -1.0f
const real | kRealOne = 1.0f
const real | kRealTwo = 2.0f
const real | kRealZero = 0.0f
const real | kReal32767 = float(my2pow15Minus1)
const real | kRealMax = float(1e20)
const real | kRealMin = float(-1e20)
const real | kRealMinus32767 = float(-my2pow15Minus1)
const real | kRealEpsilon = float(1.0/my2pow14)
const real | kRealOneHalf = 0.5f
const real | kRealOneThird = 1.0f/3.0f
const real | kRealTwoThirds = 2.0f/3.0f
const real | kRealOneFourth = 0.25f
const real | kRealPI = float(mypi)
const real | kRealTwoPI = float(mypi*2.0)
const real | kRealHalfPI = float(mypi/2.0)
const real | kRealThirdPI = float(mypi/3.0)
const real | kRealFourthPI = float(mypi/4.0)
const real | kRealRadToDeg = float(180.0/mypi)
const real | kRealDegToRad = float(mypi/180.0)
const real | kRealLogTwo = 0.6931471805599f
const real | kRealBig = float(my2pow14)
const real64 | kDouble2fixmagic = 68719476736.0*1.5

## Define Documentation

#define Div | ( | xx,
|  | yy |  | ) | ((xx)/(yy))

#define DivClip | ( | xx,
|  | yy |  | ) | ((xx)/(yy))

#define dsOverflow 32000

#define Mul | ( | xx,
|  | yy |  | ) | ((xx)*(yy))

#define my2pow14 16384.0

#define my2pow15Minus1 32767.0

#define mypi 3.1415926535

## Function Documentation

real DegToRad | ( | real | xx | ) | `[inline]`

real FixedToReal | ( | int32 | xx | ) | `[inline]`

real Int16ToReal | ( | int16 | xx | ) | `[inline]`

real Int32ToReal | ( | int32 | xx | ) | `[inline]`

int MultiplyClip | ( | real & | xx,
|  | const real | yy |
| ) |  |  | `[inline]`

real RadToDeg | ( | real | xx | ) | `[inline]`

real Real32ToReal | ( | real32 | xx | ) | `[inline]`

real Real64ToReal | ( | real64 | value | ) | `[inline]`

real Real64ToRealCheck | ( | real64 | value,
|  | int * | overflow = `0` |
| ) |  |  | `[inline]`

real RealAbs | ( | real | xx | ) | `[inline]`

void RealArcSinCos | ( | real | sin,
|  | real | cos,
|  | real & | angle |
| ) |  |  |

real RealAtan2 | ( | real | sin,
|  | real | cos |
| ) |  |  | `[inline]`

real RealCeil | ( | real | xx | ) | `[inline]`

real RealCos | ( | real | xx | ) | `[inline]`

real RealDiv16 | ( | real | xx | ) | `[inline]`

real RealDiv2 | ( | real | xx | ) | `[inline]`

real RealDiv4 | ( | real | xx | ) | `[inline]`

real RealDiv8 | ( | real | xx | ) | `[inline]`

real RealExp | ( | real | xx | ) | `[inline]`

real RealFloor | ( | real | xx | ) | `[inline]`

real RealLog | ( | real | xx | ) | `[inline]`

real RealMul16 | ( | real | xx | ) | `[inline]`

real RealMul2 | ( | real | xx | ) | `[inline]`

real RealMul2Power | ( | real | xx,
|  | int16 | yy |
| ) |  |  |

real RealMul4 | ( | real | xx | ) | `[inline]`

real RealMul8 | ( | real | xx | ) | `[inline]`

real RealPow | ( | real | xx,
|  | real | yy |
| ) |  |  | `[inline]`

real RealSin | ( | real | xx | ) | `[inline]`

void RealSinCos | ( | real | angle,
|  | real & | sin,
|  | real & | cos |
| ) |  |  |

real RealSqrt | ( | real | xx | ) | `[inline]`

real RealTan | ( | real | xx | ) | `[inline]`

int32 RealToFixed | ( | real | xx | ) | `[inline]`

int16 RealToInt16 | ( | real | xx | ) | `[inline]`

int32 RealToInt32 | ( | real | xx | ) | `[inline]`

real32 RealToReal32 | ( | real | xx | ) | `[inline]`

real64 RealToReal64 | ( | real | xx | ) | `[inline]`

void RealToReal64 | ( | real | xx,
|  | real64 & | value |
| ) |  |  | `[inline]`

uint16 RealToUInt16 | ( | real | xx | ) | `[inline]`

uint32 RealToUInt32 | ( | real | xx | ) | `[inline]`

int16 RoundRealToInt16 | ( | real | xx | ) | `[inline]`

int32 RoundRealToInt32 | ( | real | xx | ) | `[inline]`

real32 Spline | ( | real32 | x,
|  | const int32 | knotsCount,
|  | real32 * | knots |
| ) |  |  |

real32 Spline4 | ( | real32 | x,
|  | real32 * | knots |
| ) |  |  |

int16 TruncRealToInt16 | ( | real | xx | ) | `[inline]`

int32 TruncRealToInt32 | ( | real | xx | ) | `[inline]`

uint16 TruncRealToUInt16 | ( | real | xx | ) | `[inline]`

uint32 TruncRealToUInt32 | ( | real | xx | ) | `[inline]`

real UInt16ToReal | ( | uint16 | xx | ) | `[inline]`

real UInt32ToReal | ( | uint32 | xx | ) | `[inline]`

## Variable Documentation

const real64 kDouble2fixmagic = 68719476736.0*1.5

const real kReal32767 = float(my2pow15Minus1)

const real kRealBig = float(my2pow14)

const real kRealDegToRad = float(mypi/180.0)

const real kRealEpsilon = float(1.0/my2pow14)

const real kRealFourthPI = float(mypi/4.0)

const real kRealHalfPI = float(mypi/2.0)

const real kRealLogTwo = 0.6931471805599f

const real kRealMax = float(1e20)

const real kRealMin = float(-1e20)

const real kRealMinus32767 = float(-my2pow15Minus1)

const real kRealMinusOne = -1.0f

const real kRealOne = 1.0f

const real kRealOneFourth = 0.25f

const real kRealOneHalf = 0.5f

const real kRealOneThird = 1.0f/3.0f

const real kRealPI = float(mypi)

const real kRealRadToDeg = float(180.0/mypi)

const real kRealThirdPI = float(mypi/3.0)

const real kRealTwo = 2.0f

const real kRealTwoPI = float(mypi*2.0)

const real kRealTwoThirds = 2.0f/3.0f

const real kRealZero = 0.0f